;
;	TRUEMAZE - CIO compatible version by XXL and JAC!
;

;
; System equates
;
; OS EQUATES
; ----------
; 
; Syntax:
; Use '=' for addresses
; and '<' for read addresses (ex: KBCODE)
; and '>' for write addresses (ex: STIMER)
; and '#' for values
; 
; IO EQUATES
; 
ICCOM	= $0002
ICBAL	= $0004
ICBAH	= $0005
ICBLL	= $0008
ICBLH	= $0009
ICAX1	= $000A
ICAX2	 = $000B

; 
; DISPLAY LIST EQUATES

; 
; OS VARIABLES FOR XL/XE
; 
; PAGE 0
; 

RTCLOK      = $0012

ROWCRS      = $0054
COLCRS      = $0055

OLDROW      = $005A
OLDCOL      = $005B

zp_x	= $0080
zp_y	= $0081

ATACHR      = $02FB

; 
; PAGE 3
; 

IOCB0	= $0340

RANDOM      = $D20A

; 
; ROM VECTORS
; 
CIOV	 = $E456

;
; Code equates
;
L0082	= $0082
L0083	= $0083
L0084	= $0084
L008A	= $008A
L008F	= $008F
L0090	= $0090
LFFFF	= $FFFF

	.macro m_jmp_ciov
	jmp CIOV
	.endm

;
; Start of code
;
	org $02E0
;
	.word L00A4
;
	org L008A			;For for Atari XL OS
	.byte $00,$00,$02,$04

;	org L008A+2
;	.byte $02,$04

L008E	sta LFFFF
	inc L008F
	bne L0097
	inc L0090
L0097	rts

L0098	.byte $A7,L00A3	;LAX zp
	.byte $C7,L008E+1	;DCP zp
	bne L00A0
	dec L0090
L00A0	lda (L0090,X)
	rts
L00A3	.byte $FF

L00A4	lda #$1F
	jsr GRAPHICS_L0617
	lda #$02
	sta L008F
	lda #$70
	sta L0090
L00B1	lda L008F
	bne L00C5
	lda L0090
	cmp #$70
	bne L00C5
	lda #$80
	sta RTCLOK+2
L00BF	lda RTCLOK+2
	bne L00BF
	beq L00A4
L00C5	jsr L0098
	sta zp_x
	jsr L0098
	sta zp_y
L00CF	lda #$00
	sta L0082
	jsr L0164
	bcs L00DB
	jsr L0174
L00DB	jsr L0158
	bcs L00E3
	jsr L0174
L00E3	jsr L014A
	bcs L00EB
	jsr L0174
L00EB	jsr L0131
	bcs L00F3
	jsr L0174
L00F3	lda L0082
	beq L00B1
	ldx zp_x
	ldy zp_y
	lda #$01
	sta ATACHR
	sty OLDROW
	stx OLDCOL
L0104
	lda RANDOM
	and #$06
	beq L0104
	cmp L0082
	beq L0111
	bcs L0104
L0111	lsr
	tay
	ldx L008A,Y
	lda L0084,X
	tay
	sty zp_y
	jsr L008E
	lda L0083,X
	tax
	stx zp_x
	jsr L008E
	sty ROWCRS
	stx COLCRS
	lda #$01
	jsr DRAWTO_L066B
	jmp L00CF
L0131	ldx zp_x
	inx
	inx
	cpx #$A0
	bcs L0148
	ldy zp_y
L013B
	stx COLCRS
	sty ROWCRS
	jsr GET_CHAR_AT_L0662
	cmp #$00
	bne L0148
	clc
	rts
L0148	sec
	rts

L014A	.byte $A7,zp_x
	.byte $CB,$02	;AXS #imm
	bcc L0148
	ldy zp_y
	cpx #$00
	bcc L0148
	bcs L013B
L0158
	ldx zp_x
	ldy zp_y
	iny
	iny
	cpy #$C0
	bcs L0148
	bcc L013B

L0164	ldx zp_x
	lda zp_y
	sec
	sbc #$02
	tay
	bcc L0148
	cpy #$00
	bcc L0148
	bcs L013B
L0174	ldx L0082
	lda COLCRS
	sec
	sbc #$01
	sta L0083,X
	inx
	lda ROWCRS
	sta L0083,X
	inx
	stx L0082
	rts

	org $0600

CLOSE_L600  lda #$0C
	sta IOCB0+ICCOM,X
	m_jmp_ciov

OPEN_L0608
	sta IOCB0+ICAX1,X
	tya
	sta IOCB0+ICAX2,X
	lda #$03
	sta IOCB0+ICCOM,X
	m_jmp_ciov

GRAPHICS_L0617
      pha
	ldx #$60
	jsr CLOSE_L600
	ldx #$60
	lda #<L0634
	sta IOCB0+ICBAL,X
	lda #>L0634
	sta IOCB0+ICBAH,X
	pla
	tay
	and #$30
	eor #$10
	ora #$0C
	jmp OPEN_L0608
L0634	.byte 'S:',$9b

PUT_CHAR_L0637
	tay
	lda #$00
	sta IOCB0+ICBLL,X
	sta IOCB0+ICBLH,X
	lda #$0B	; PUT CHARCTERS
	sta IOCB0+ICCOM,X
	tya
	m_jmp_ciov

GET_CHAR_L0649
	lda #$00
	sta IOCB0+ICBLL,X
	sta IOCB0+ICBLH,X
	lda #$07
	sta IOCB0+ICCOM,X
	m_jmp_ciov

PUT_CHAR_AT_L0659
	stx COLCRS
	sty ROWCRS
	ldx #$60
	jmp PUT_CHAR_L0637

GET_CHAR_AT_L0662
	stx COLCRS
	sty ROWCRS
	ldx #$60
	jmp GET_CHAR_L0649

DRAWTO_L066B
	stx COLCRS
	sty ROWCRS
	sta ATACHR
	ldx #$60
	lda #$11
	sta IOCB0+ICCOM,X
	m_jmp_ciov
;

;;	##TRACE "Before CIOV a=$%02x x=$%02x y=$%02x CMD=$%02x ROWCRS=%d"  a x y db($342+$60) db(ROWCRS)
;_CIOV	jsr CIOV
;	cpy #$80
;	bcs error
;;	##TRACE "Aftr   CIOV a=$%02x x=$%02x y=$%02x CMD=$%02x ROWCRS=%d"  a x y db($342+$60) db(ROWCRS)
;	rts	
;error	.byte 2
